﻿<html>
<head>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
	<script src="chartist.js"></script>
	<link rel="stylesheet" href="chartist.css" media="all">

	<style>
		body {
			padding: 20px;
		}

		h1 {
			padding: 20px 0;
			text-align: center;
		}

		.ct-chart {
			display: block;
			max-width: 800px;
			margin: 30px auto;
			padding: 20px;
			box-sizing: border-box;
		}

		.ct-label {
			font-size: 18px;
			fill: #000000;
			color: #000000;
		}
	</style>
</head>
<body>


<h1 class="ct-chart-title"></h1>
<div class="ct-chart ct-perfect-fourth"></div>

<script>
	// Диаграммы строятся при помощи https://gionkunz.github.io/chartist-js
	// Рисуем горизонтальную диаграмму ---------------------------------------------------------------------------------
	// labels_array - массив строк подписей
	// series_array - массив числовых значений
	function HorizontalBarChart(labels_array, series_array) {
		new Chartist.Bar('.ct-chart', {
			labels: labels_array,
			series: series_array
		}, {
			seriesBarDistance: 10, // Расстояние между сериями
			reverseData: true, // Прямой или обратный порядок строк
			horizontalBars: true, // Переключение вертикальная или горизонтальная
			scaleMinSpace: 1,
			axisY: {
				offset: 300 // Пространство под надпись
			}
		});
	}
	// Рисуем круговую диаграмму ---------------------------------------------------------------------------------------
	// labels_array - массив строк подписей
	// series_array - массив числовых значений
	function PieChart(labels_array, series_array) {
		var data = {
			labels: labels_array,
			series: series_array
		};

		var options = {
			labelInterpolationFnc: function (value) {
				return value[0]
			}
		};

		var responsiveOptions = [
			['screen and (min-width: 640px)', {
				chartPadding: 30,
				labelOffset: 100,
				labelDirection: 'explode',
				labelInterpolationFnc: function (value) {
					return value;
				}
			}],
			['screen and (min-width: 1024px)', {
				labelOffset: 80,
				chartPadding: 20
			}]
		];

		new Chartist.Pie('.ct-chart', data, options, responsiveOptions);
	}
	// Разбираем параметры URL  ----------------------------------------------------------------------------------------
	function getUrlParameters(id, type) {
		var url_parameters = {};
		var parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (m, key, value) {
			url_parameters[key] = value;
		});
		return url_parameters;
	}
	// -----------------------------------------------------------------------------------------------------------------
	function Init() {

		var url_parameters = getUrlParameters(); // Разбираем параметры URL
		$.ajax(
			{
				url: url_parameters.id,
				type: 'GET',
				success: function (data) {
					var response = JSON.parse(data);
					var test_title = response.test_title;
					$('.ct-chart-title').text(test_title);
					var results = response.test_results[0];
					var labels_array = [];
					var series_array = [];

					for (var i = 0; i < results.length; i++) {
						labels_array[i] = results[i]['text'];
						series_array[i] = results[i]['value'];
					}

					// Обработка типа диаграммы
					switch (url_parameters.type) {
						case 'horizontal':
							HorizontalBarChart(labels_array, [series_array]); // Рисуем горизонтальную диаграмму
							break;
						case 'pie':
							PieChart(labels_array, series_array); // Рисуем круговую диаграмму
							break;
						default:
							HorizontalBarChart(labels_array, [series_array]); // Рисуем горизонтальную диаграмму
							break;
					}
				}
			});
	}
	// -----------------------------------------------------------------------------------------------------------------
	$(document).ready(function () {
		Init(); // Запуск
	});
</script>

</body>
</html>

